<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Unit Conversion and Dimensional Analysis Library: Explicit Conversion</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Unit Conversion and Dimensional Analysis Library
   &#160;<span id="projectnumber">2.3.0</span>
   </div>
   <div id="projectbrief">A compile-time c++14 unit conversion library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Explicit Conversion</div>  </div>
</div><!--header-->
<div class="contents">

<p>Functions used to convert values of one logical type to another.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gaa03816ee32bb44ddbd6bc866ef89b231"><td class="memTemplParams" colspan="2">template&lt;class UnitFrom , class UnitTo , typename T  = double&gt; </td></tr>
<tr class="memitem:gaa03816ee32bb44ddbd6bc866ef89b231"><td class="memTemplItemLeft" align="right" valign="top">static constexpr T&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___conversion.html#gaa03816ee32bb44ddbd6bc866ef89b231">units::convert</a> (const T &amp;value) noexcept</td></tr>
<tr class="memdesc:gaa03816ee32bb44ddbd6bc866ef89b231"><td class="mdescLeft">&#160;</td><td class="mdescRight">converts a <em>value</em> from one type to another.  <a href="group___conversion.html#gaa03816ee32bb44ddbd6bc866ef89b231">More...</a><br /></td></tr>
<tr class="separator:gaa03816ee32bb44ddbd6bc866ef89b231"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga850c3e5c380d1eb1d718128966819c70"><td class="memTemplParams" colspan="2">template&lt;typename T , typename Units , class  = std::enable_if_t&lt;std::is_arithmetic&lt;T&gt;::value &amp;&amp; traits::is_unit_t&lt;Units&gt;::value&gt;&gt; </td></tr>
<tr class="memitem:ga850c3e5c380d1eb1d718128966819c70"><td class="memTemplItemLeft" align="right" valign="top">constexpr T&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="group___conversion.html#ga850c3e5c380d1eb1d718128966819c70">units::unit_cast</a> (const Units &amp;value) noexcept</td></tr>
<tr class="memdesc:ga850c3e5c380d1eb1d718128966819c70"><td class="mdescLeft">&#160;</td><td class="mdescRight">Casts a unit container to an arithmetic type.  <a href="group___conversion.html#ga850c3e5c380d1eb1d718128966819c70">More...</a><br /></td></tr>
<tr class="separator:ga850c3e5c380d1eb1d718128966819c70"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>Functions used to convert values of one logical type to another. </p>
<h2 class="groupheader">Function Documentation</h2>
<a id="gaa03816ee32bb44ddbd6bc866ef89b231"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaa03816ee32bb44ddbd6bc866ef89b231">&#9670;&nbsp;</a></span>convert()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class UnitFrom , class UnitTo , typename T  = double&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static constexpr T units::convert </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">constexpr</span><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>converts a <em>value</em> from one type to another. </p>
<p>Converts a <em>value</em> of a built-in arithmetic type to another unit. This does not change the type of <em>value</em>, only what it contains. E.g.</p><div class="fragment"><div class="line"><span class="keywordtype">double</span> result = convert&lt;length::meters, length::feet&gt;(1.0); <span class="comment">// result == 3.28084 </span></div>
</div><!-- fragment --> <dl class="section see"><dt>See also</dt><dd><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a> for implicit conversion of <a class="el" href="structunits_1_1unit.html" title="Type representing an arbitrary unit.">unit</a> containers. </dd></dl>
<dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">UnitFrom</td><td>unit tag to convert <em>value</em> from. Must be a <code>unit</code> type (i.e. is_unit&lt;UnitFrom&gt;::value == true), and must be convertible to <code>UnitTo</code> (i.e. is_convertible_unit&lt;UnitFrom, UnitTo&gt;::value == true). </td></tr>
    <tr><td class="paramname">UnitTo</td><td>unit tag to convert <em>value</em> to. Must be a <code>unit</code> type (i.e. is_unit&lt;UnitTo&gt;::value == true), and must be convertible from <code>UnitFrom</code> (i.e. is_convertible_unit&lt;UnitFrom, UnitTo&gt;::value == true). </td></tr>
    <tr><td class="paramname">T</td><td>type of <em>value</em>. It is inferred from <em>value</em>, and is expected to be a built-in arithmetic type. </td></tr>
  </table>
  </dd>
</dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">value</td><td>Arithmetic value to convert from <code>UnitFrom</code> to <code>UnitTo</code>. The value should represent a quantity in units of <code>UnitFrom</code>. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>value, converted from units of <code>UnitFrom</code> to <code>UnitTo</code>. </dd></dl>

</div>
</div>
<a id="ga850c3e5c380d1eb1d718128966819c70"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga850c3e5c380d1eb1d718128966819c70">&#9670;&nbsp;</a></span>unit_cast()</h2>

<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T , typename Units , class  = std::enable_if_t&lt;std::is_arithmetic&lt;T&gt;::value &amp;&amp; traits::is_unit_t&lt;Units&gt;::value&gt;&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr T units::unit_cast </td>
          <td>(</td>
          <td class="paramtype">const Units &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">constexpr</span><span class="mlabel">noexcept</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Casts a unit container to an arithmetic type. </p>
<p>unit_cast can be used to remove the strong typing from a unit class, and convert it to a built-in arithmetic type. This may be useful for compatibility with libraries and legacy code that don't support <code><a class="el" href="classunits_1_1unit__t.html" title="Container for values which represent quantities of a given unit.">unit_t</a></code> types. E.g </p><div class="fragment"><div class="line">meter_t unitVal(5);</div>
<div class="line"><span class="keywordtype">double</span> value = units::unit_cast&lt;double&gt;(unitVal);  <span class="comment">// value = 5.0 </span></div>
</div><!-- fragment --> <dl class="tparams"><dt>Template Parameters</dt><dd>
  <table class="tparams">
    <tr><td class="paramname">T</td><td>Type to cast the unit type to. Must be a built-in arithmetic type. </td></tr>
  </table>
  </dd>
</dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>Unit value to cast. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="classunits_1_1unit__t.html#a848f265210db571a1f7d13aae96c8dd5" title="unit value">unit_t::to</a> </dd></dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Sat Oct 3 2020 11:16:53 for Unit Conversion and Dimensional Analysis Library by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
